WoMax Documentation

# t_OMax_SLT Struct Reference
[Max5 Externals, Factor Oracle structure]

OMax.SLT external. More...

Collaboration diagram for t_OMax_SLT:
[legend]

List of all members.

## Public Attributes
t_object | ob
| Pointer to the object itself.
t_symbol * | oname
| Pointer to FO name.
bool | obound
| Binding flag.
O_oracle * | oracle
| Pointer to FO structure.
long | context
| Minimal context (lrs) for pruning.
void * | out_root
| Outlet 0 (leftmost): root of the tree.
void * | out_SLT
| Outlet 1: every state in the tree.
void * | out_path
| Outlet 2: path from the given state to the root.
## Standard Max5 methodes
void * | OMax_SLT_new (t_symbol *s, long argc, t_atom *argv)
| Object instantiation.
void | OMax_SLT_free (t_OMax_SLT *x)
| Object destruction.
void | OMax_SLT_assist (t_OMax_SLT *x, void *b, long io, long index, char *s)
| Inlet/Outlet contextual information when patching in Max5.
## Internal routines
bool | OMax_SLT_bind (t_OMax_SLT *x)
| Bind the object with FO.
## Input/Output routines
void | OMax_SLT (t_OMax_SLT *x, long statnb)
| Output Suffix Link Tree (SLT) prunned to the minimal context .
void | OMax_path (t_OMax_SLT *x, long statnb)
| Output the path from a state to the root of the (prunned) SLT.
void | OMax_fullpath (t_OMax_SLT *x, long statnb)
| Output the whole suffix path from a state to state 0 of FO.
void | OMax_sortedSLT (t_OMax_SLT *x, long statnb)
| Output Suffix Link Tree (SLT) prunned to the minimal context and sorted by decreasing context length.
void | OMax_ctxt (t_OMax_SLT *x, long ctxtin)
| Change minimal context .

## Detailed Description

OMax.SLT external.

This externals allows to follow suffix and reverse suffix links in an FO structure (implemented with the external OMax.oracle ) in Max5 and output the corresponding tree

Definition at line 29 of file OMax.SLT.c.

## Member Function Documentation

void OMax_ctxt | ( | t_OMax_SLT * | x,
|  | long | ctxtin |
| ) |  |  |

Change minimal context .

Remarks:
  Input message in Max5: the new minimal context (`int`) in the right inlet

Definition at line 417 of file OMax.SLT.c.

void OMax_fullpath | ( | t_OMax_SLT * | x,
|  | long | statnb |
| ) |  |  |

Output the whole suffix path from a state to state 0 of FO.

Remarks:
  Input message in Max5: `fullpath` followed by a state number (`int`)

Follow suffix links up to the root of the tree with minimal context set to 0

Output the whole path

Output the root (0)

Definition at line 327 of file OMax.SLT.c.

Here is the call graph for this function:

void OMax_path | ( | t_OMax_SLT * | x,
|  | long | statnb |
| ) |  |  |

Output the path from a state to the root of the (prunned) SLT.

Remarks:
  Input message in Max5: `path` followed by a state number (`int`)

Follow suffix links up to the root of the tree

Output the path from the input state to the root

Output the root of the tree

Definition at line 282 of file OMax.SLT.c.

Here is the call graph for this function:

void OMax_SLT | ( | t_OMax_SLT * | x,
|  | long | statnb |
| ) |  |  |

Output Suffix Link Tree (SLT) prunned to the minimal context .

Remarks:
  Input message in Max5: a state number (`int`)

Follow suffix links up to the root of the tree

Output the path from the input state to the root

Output the whole tree following every reverse suffix link

Output the root of the tree

Definition at line 216 of file OMax.SLT.c.

Here is the call graph for this function:

bool OMax_SLT_bind | ( | t_OMax_SLT * | x | ) |

Bind the object with FO.

Remarks:
  Do this binding only once

Check if FO name points to an existing OMax.oracle object. If so, set t_OMax_SLT::oracle to point to the FO structure (t_OMax_oracle::oracle member)

Definition at line 188 of file OMax.SLT.c.

void * OMax_SLT_new | ( | t_symbol * | s,
|  | long | argc,
|  | t_atom * | argv |
| ) |  |  |

Object instantiation.

Check first argument of the Max5 object for a FO name

Set the minimal context to the value of the 2nd argument of the Max5 object if given (set to 1 otherwise)

Definition at line 97 of file OMax.SLT.c.

void OMax_sortedSLT | ( | t_OMax_SLT * | x,
|  | long | statnb |
| ) |  |  |

Output Suffix Link Tree (SLT) prunned to the minimal context and sorted by decreasing context length.

Remarks:
  Input message in Max5: `sorted` followed by a state number (`int`)

Output the root of the tree

Definition at line 372 of file OMax.SLT.c.

Here is the call graph for this function:

The documentation for this struct was generated from the following file:

- OMax.SLT.c